<?php

/**
 * aprueba_remate actions.
 *
 * @package    cobro_coactivo
 * @subpackage aprueba_remate
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class aprueba_remateActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_APRUEBA_REMATE',
        'CBR_REMATE',
        'CBR_SECUESTRO',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUALIZA_TITULO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_REMATE' =>
        array(
            'id_remate' => 'CBR_APRUEBA_REMATE'
        ),
        'CBR_SECUESTRO' =>
        array(
            'id_secuestro' => 'CBR_REMATE'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_SECUESTRO'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ACTUALIZA_TITULO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_APRUEBA_REMATE' =>
        array(
            'id_aprueba_remate' => 'id_aprueba_remate',
            'id_remate' => 'id_remate',
            'no_acta' => 'no_acta',
            'fecha_acta' => 'fecha_acta',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto'
        ),
        'CBR_REMATE' =>
        array(
            'id_secuestro' => 'id_secuestro',
            'no_acta' => 'auto_remate',
            'fecha_remate' => 'fecha_remate',
        ),
        'CBR_SECUESTRO' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral_deb',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral_deb'
        ),
        'CBR_ACTUALIZA_TITULO_V' =>
        array(
            'mineral' => 'mineral',
            'id_mineral' => 'id_mineral',
            'cod_mineral' => 'cod_mineral'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_APRUEBA_REMATE' =>
        array(
            'id_aprueba_remate,a' => array('!=' => array(-1)),
            'id_aprueba_remate,b' => array('=' => array('id_aprueba_remate')),
            'id_remate' => array('=' => array('id_remate')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo')),
            'anho_remision' => array('=' => array('anho_remision'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_aprueba_remate'; //identificador de la tabla
    protected $id_names = array('id_aprueba_remate'); //llave primaria
    protected $field_names = array('id_remate', 'no_acta', 'fecha_acta', 'observaciones', 'adjunto','detalle_plantilla',
        'id_plantilla','id_tipo_documento','usuario_log','fecha_log','usuario_aprueba','fecha_aprueba'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_APRUEBA_REMATE'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_aprueba_remate'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        $id_aprueba_remate = $list_data_post[0]['id_aprueba_remate'];
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {
            

                if ($request['id_plantilla'] != "") {
                    $id_plantilla = $request['id_plantilla'];
                    $sql = <<<EOD
UPDATE CBR_APRUEBA_REMATE SET DETALLE_PLANTILLA=(select detalle from cbr_plantilla where id_plantilla = $id_plantilla) where id_aprueba_remate=$id_aprueba_remate
EOD;


                    $this->conn->execute($sql);
                }
                if($request['estado']==1){
                    //Metodo Sobreescribir Documento
                    //setlocale(LC_ALL, 'es_ES');
                    //$fechaDocumento = date('d-F-Y',strtotime($list_data_post[0]['fecha_aprueba']));
                    $meses = array("Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre");
                    $dia = date('d',strtotime($list_data_post[0]['fecha_aprueba']));
                    $mes = $meses[date('m',strtotime($list_data_post[0]['fecha_aprueba'])) - 1];
                    $año = date('Y',strtotime($list_data_post[0]['fecha_aprueba']));
                    $fechaDocumento = "$dia - $mes - $año";
                    $datosModificar = Array(
                        'numeroDocumento' => $list_data_post[0]['no_acta'],
                        'fechaDocumento' => $fechaDocumento
                    );
                    //Obtenemos la ruta donde e almacena el adjunto
                    
                    $ruta_documento = getcwd() . "/uploads/aprueba_remate/";
                    $documento = $ruta_documento.$list_data_post[0]['adjunto'];
                    $logger->info("Actualizar Documento - " . $documento);
                    $new_documento = CN_TABLE::sobreescribirDocumentoWord($datosModificar, $documento);
                    $logger->info("Se Actaulizo el documento - $documento y se creo $new_documento");
                    // Actualizamos el archivo en el campo Adjunto
                    $sql = <<<EOD
update CBR_APRUEBA_REMATE SET ADJUNTO = '$new_documento'  
 where id_aprueba_remate = $id_aprueba_remate
EOD;
                    $this->conn->execute($sql);
                  //LLamar envioNotificacion
                    $this->envioNotificacion($request, $id_aprueba_remate);  
                }
                  
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
            if($request['estado']==1){
                //Metodo Sobreescribir Documento
                //setlocale(LC_ALL, 'es_ES');
                //$fechaDocumento = date('d-F-Y',strtotime($list_data_post[0]['fecha_aprueba']));
                $meses = array("Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre");
                    $dia = date('d',strtotime($list_data_post[0]['fecha_aprueba']));
                    $mes = $meses[date('m',strtotime($list_data_post[0]['fecha_aprueba'])) - 1];
                    $año = date('Y',strtotime($list_data_post[0]['fecha_aprueba']));
                    $fechaDocumento = "$dia - $mes - $año";
                    $datosModificar = Array(
                        'numeroDocumento' => $list_data_post[0]['no_acta'],
                        'fechaDocumento' => $fechaDocumento
                    );
                    //Obtenemos la ruta donde e almacena el adjunto
                    
                    $ruta_documento = getcwd() . "/uploads/aprueba_remate/";
                    $documento = $ruta_documento.$list_data_post[0]['adjunto'];
                    $logger->info("Actualizar Documento - " . $documento);
                    $new_documento = CN_TABLE::sobreescribirDocumentoWord($datosModificar, $documento);
                    $logger->info("Se Actaulizo el documento - $documento y se creo $new_documento");
                    // Actualizamos el archivo en el campo Adjunto
                    $sql = <<<EOD
update CBR_APRUEBA_REMATE SET ADJUNTO = '$new_documento'  
 where id_aprueba_remate = $id_aprueba_remate
EOD;
                    $this->conn->execute($sql);
                  //LLamar envioNotificacion
                    $this->envioNotificacion($request, $id_aprueba_remate);  
            }
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
            if(isset($request['estado'])&&$request['estado']==true){
                            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS, to_char(sysdate,'yyyy-mm-dd') as fecha_actual FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];
            $fecha_actual = $records[0]['fecha_actual'];


            $id_tipo_documento = 2; //ACTA
            $request['id_tipo_documento']=$id_tipo_documento;
            $request['usuario_log']=$request['id_username'];
            $request['usuario_aprueba']=$request['id_username'];
            $request['fecha_log']=$fecha_actual;
            $request['fecha_aprueba']=$fecha_actual;


            $sql = <<<EOD
select consecutivo from cbr_consecutivo_doc where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $consecutivo = $records[0]['consecutivo'];

            $request['no_acta'] = $consecutivo;
            
            $request['no_acta'] = str_pad($request['no_acta'], 4, "0", STR_PAD_LEFT);
            $request['estado']=1;

            $sql = <<<EOD
update cbr_consecutivo_doc set consecutivo =($consecutivo+1) where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;

            CN_TABLE::executeSQL($sql);
        } else {
            
            
                              $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS, to_char(sysdate,'yyyy-mm-dd') as fecha_actual FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];
            $fecha_actual = $records[0]['fecha_actual'];


            $id_tipo_documento = 2; //ACTA
            $request['id_tipo_documento']=$id_tipo_documento;
            $request['usuario_log']=$request['id_username'];
            //$request['usuario_aprueba']=$request['id_username'];
            $request['fecha_log']=$fecha_actual;
            //$request['fecha_aprueba']=$fecha_actual;
               
        
            $request['no_acta']='0';
            $request['estado']=0;
            
        }
            

        }

        //accion update
        if ($Action == "UPDATE") {
            
                if(isset($request['estado'])&&$request['estado']==true){
                            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS, to_char(sysdate,'yyyy-mm-dd') as fecha_actual FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];
            $fecha_actual = $records[0]['fecha_actual'];


            $id_tipo_documento = 2; //ACTA
            $request['id_tipo_documento']=$id_tipo_documento;
            $request['usuario_log']=$request['id_username'];
            $request['usuario_aprueba']=$request['id_username'];
            $request['fecha_log']=$fecha_actual;
            $request['fecha_aprueba']=$fecha_actual;


            $sql = <<<EOD
select consecutivo from cbr_consecutivo_doc where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $consecutivo = $records[0]['consecutivo'];

            $request['no_acta'] = $consecutivo;
            
            $request['no_acta'] = str_pad($request['no_acta'], 4, "0", STR_PAD_LEFT);
            $request['estado']=1;

            $sql = <<<EOD
update cbr_consecutivo_doc set consecutivo =($consecutivo+1) where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;

            CN_TABLE::executeSQL($sql);
        } else {
            
            
                              $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS, to_char(sysdate,'yyyy-mm-dd') as fecha_actual FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];
            $fecha_actual = $records[0]['fecha_actual'];


            $id_tipo_documento = 2; //ACTA
            $request['id_tipo_documento']=$id_tipo_documento;
            $request['usuario_log']=$request['id_username'];
            //$request['usuario_aprueba']=$request['id_username'];
            $request['fecha_log']=$fecha_actual;
            //$request['fecha_aprueba']=$fecha_actual;
               
        
            $request['no_acta']='0';
            $request['estado']=0;
            
        }
            
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }
    
    
    
         /**
     * Correo de notificacion de aprobacion - 20200304
     * 
     * @param type $request
     * @param type $id_filtro
     */
    public function envioNotificacion($request, $id_filtro) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a envioNotificacion");

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        $correoEnvio = "";
        $service_url = "";
        foreach ($array as $routeName => $routeData) {
            if ('service_url_local' == $routeName) {
                foreach ($routeData as $key => $value) {
                    if ($key == 'value') {
                        $service_url = $value;
                    }
                }
            }
            if ('correoEnvio' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $correoEnvio = $value;
                    }
                }
            }
            $int++;
        }

        /**
         * Envio de correo de error - 20190911
         */
        $logger->info("Envio de correo inicio ");

        //URL de servicio correo
        $url = $service_url . "curl_envio_correo/list.json";

        $comando = $request['comando'];
        $id_username = $request['id_username'];
        $username = $request['username'];

        //obtener id maestro tabla
        $id_mae_bd = CN_TABLE::consultarIdTablaBD('CBR_APRUEBA_REMATE');

        //Sql
        $sql = <<<EOD
select 
                
usu.username,
'$comando' as comando,               
car.id_aprueba_remate as id_tabla,
'$id_mae_bd' as id_mae_bd,
'$id_username' as id_username,
                
car.id_aprueba_remate,
car.no_acta,
remi.numero_remision,
remi.anho_remision as id_anhos,
remi.cod_titulo,
ter.id_tipo_doc,
ter.num_doc,
ter.razon_soc,
abo.email as correo,
'$correoEnvio' as email_envio,
'' as mensaje_extra,
'' as mensaje_firma,
'Se realiza la aprobación del remate registo '|| tipdoc.descripcion || ' No.'|| car.no_acta || ' del titulo minero ' || remi.cod_titulo  || ', verificar recepcion No.'|| remi.numero_remision || '-' || remi.anho_remision 
    || ', se envia correo al abogado( '|| ter.num_doc || '-' || ter.razon_soc ||' ).' as mensaje,
'Aprobacion REMATE - Recepcion No.'|| remi.numero_remision || '-' || remi.anho_remision || ' del Titulo: ' || remi.cod_titulo as subject,                        
                
--datos de envio
ter.num_doc as num_doc_env,
ter.id_tipo_doc as id_tipo_doc_env,
ter.razon_soc as razon_social_env,
abo.email as correo_env,

--datos de envio usuario
usu.num_doc as num_doc_usu,
usu.id_tipo_doc as id_tipo_doc_usu,
usu.nombre || ' ' || usu.nombre as razon_social_usu,
usu.email as correo_usu

from cbr_aprueba_remate car

left join cbr_remate cre
on car.id_remate=cre.id_remate

left join cbr_secuestro avoc
on avoc.id_secuestro=cre.id_secuestro


left join cbr_tipo_documento tipdoc
on tipdoc.id_tipo_documento = avoc.id_tipo_documento

left join cbr_reparto repa
on repa.id_remision_titulo = avoc.id_remision_titulo

left join cbr_remision_titulo remi
on avoc.id_remision_titulo = remi.id_remision_titulo

left join cbr_abogado abo
on abo.id_abogado = repa.id_abogado

left join interceros_v ter
on ter.id_mae_ter = abo.id_mae_ter

left join usuario usu
on usu.username = '$username'

where
car.id_aprueba_remate = $id_filtro
and car.no_acta !=0
and repa.estado = 1  
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        $this->logMessage("Envio correo");

        if (count($records) > 0) {

            /**
             * Datos de envio
             *
              $params = array(
              'user_from' => 'webservice',
              'recipients' => $recipients,
              'asunto' => 'Error webservie_sigm_consulta',
              'body' => $body
              );
             * 
             */
            $record = $records[0];

            foreach ($record as $key => $value) {
                $params[$key] = $value;
            }

            if ($service_url != null) {
                CN_TABLE::curlPostAsync($url, $params);
            }
        }

        $logger->info("Envio de correo fin");
    }

}
